<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2003 pekue (peter@kuehn.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Original functions from plugin 'pk_limitmenutolang' by pekue <peter@kuehn.com>.
 *
 * Modified to use $GLOBALS["TYPO3_CONF_VARS"]["FE"]["pageOverlayFields"] for Typo 3.5 framework (feature added in higher version).
 * This variable allows defining PAGES table overlayed fields.
 *
 * @author	Bertrand Mure <bertrand.mure@worldonline.fr>
 */

class ux_t3lib_pageSelect extends t3lib_pageSelect {
	function getMenu ($uid,$fields="*",$sortField="sorting",$addWhere="")	{
		//echo "lang is: ".$GLOBALS["TSFE"]->sys_page->sys_language_uid;
		// Returns an array with pagerows for subpages with pid=$uid (which is pid here!). This is used for menus
		$output = Array();
		$res = mysql(TYPO3_db, "SELECT ".$fields." FROM pages WHERE pid=".intval($uid).$this->where_hid_del." ".$addWhere." ORDER BY ".$sortField);
		while ($row = mysql_fetch_assoc($res)){
			$overlay=$this->getPageOverlay($row);
			if($this->sys_language_uid){
				if($row!=$overlay)$output[$row["uid"]]=$overlay;
			}else{
				$output[$row["uid"]]=$overlay;
			}
		}
		return $output;
	}
	function getPageOverlay($pageInput,$lUid=-1){
		if ($lUid<0)	$lUid=$this->sys_language_uid;
		if ($lUid)	{
			$fieldArr=explode(",",str_replace(" ", "", $GLOBALS["TYPO3_CONF_VARS"]["FE"]["pageOverlayFields"]));
			if (is_array($pageInput))	{
				$page_id=$pageInput["uid"];	// Was the whole record
				$fieldArr=array_intersect($fieldArr,array_keys($pageInput));		// Make sure that only fields which exist in the incoming record are overlaid!
			} else {
				$page_id=$pageInput;	// Was the id
			}
			$query = "SELECT ".implode(",",$fieldArr)." 
			FROM pages_language_overlay 
			WHERE pid=".intval($page_id)." 
				AND sys_language_uid=".intval($lUid).
				$this->enableFields("pages_language_overlay")." LIMIT 1";
			$res = mysql(TYPO3_db,$query);
			$row = mysql_fetch_assoc($res);
			if(is_array($row))$row["langOverlayed"]=1;
		}
		
		if (is_array($pageInput))	{
			return is_array($row) ? array_merge($pageInput,$row) : $pageInput;	// If the input was an array, simply overlay the newfound array and return...
		} else {
			return is_array($row) ? $row : array();	// always an array in return
		}
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/altern_lang_page_link/class.ux_t3lib_page.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/altern_lang_page_link/class.ux_t3lib_page.php"]);
}

?>